// DrawPart.cpp
//
//i`̊֐

#include "stdafx.h"
#include "lco.h"

#include "Draw.h"
#include "PartInfo.h"
#include "PartView.h"
#include "LCoFont.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define COL_PART (RGB(0,0,0))

	/**************************************************************************
		s̃mNrbg}bv
	
		     PinPtn[3][4][30]
		            |  |   |
		            |  |   +----zP̃oCg
		            |  +--------L T R B ̏
		            +-----------Clock,Negative,NegativeClock̏
		678901234567890
		...**.***......
		..*.**...*.....
		.*..*.....*....
		*...*.....*****		
		.*..*.....*....		
		..*.**...*.....
		...**.***......
	
	***************************************************************************/
static BYTE PinPtn[3][4][40]={

	{  //******  C L O C K  *****
		{
			// Clock L
			16,0,			//XTCY
			7,0,			//YTCY
			0x00,0x30,		//-3
			0x00,0x28,		//-2
			0x00,0x24,		//-1
			0xFF,0xE2,		//Center
			0x00,0x24,		//+1
			0x00,0x28,		//+2
			0x00,0x30		//+3
		},
	
		{
			// Clock T
			16,0,			//XTCY
			15,0,			//YTCY
			0x10,0,			//0 PinEnd
			0x10,0,			//1
			0x10,0,			//2
			0x10,0,			//3
			0x10,0,			//4
			0x10,0,			//5
			0x10,0,			//6
			0x10,0,			//7
			0x10,0,			//8
			0x10,0,			//9 
			0xFE,0,			//0 PartEdge
			0x82,0,			//1
			0x44,0,			//2
			0x28,0,			//3
			0x10,0			//4
		},
		
		{
			// Clock R
			16,0,			//XTCY
			7,0,			//YTCY
			0x18,0x00,		//-3
			0x28,0x00,		//-2
			0x48,0x00,		//-1
			0x8F,0xFE,		//Center
			0x48,0x00,		//+1
			0x28,0x00,		//+2
			0x18,0x00		//+3
		},
		
		{
			// Clock B
			16,0,			//XTCY
			15,0,			//YTCY
			0x10,0,			//6
			0x28,0,			//7
			0x44,0,			//8
			0x82,0,			//9
			0xFE,0,			//0 PartEdge
			0x10,0,			//1
			0x10,0,			//2
			0x10,0,			//3
			0x10,0,			//4
			0x10,0,			//5
			0x10,0,			//6
			0x10,0,			//7
			0x10,0,			//8
			0x10,0,			//9
			0x10,0			//0 PinEnd
		}
	},

	{  //******  N E G A T I V E *****
		{
			// Negtative L
			16,0,			//XTCY
			7,0,			//YTCY
			0x03,0x80,		//-3
			0x04,0x40,		//-2
			0x08,0x20,		//-1
			0xF8,0x20,		//Center
			0x08,0x20,		//+1
			0x04,0x40,		//+2
			0x03,0x80		//+3
		},
	
		{
			// Negtative T
			16,0,			//XTCY
			15,0,			//YTCY
			0x10,0,			//0 PinEnd
			0x10,0,			//1
			0x10,0,			//2
			0x10,0,			//3
			0x38,0,			//4
			0x44,0,			//5
			0x82,0,			//6
			0x82,0,			//7
			0x82,0,			//8
			0x44,0,			//9 
			0x38,0,			//0 PartEdge
			0,   0,			//1
			0,   0,			//2
			0,   0,			//3
			0,   0			//4
		},
		
		{
			// Negtative R
			16,0,			//XTCY
			7,0,			//YTCY
			0x03,0x80,		//-3
			0x04,0x40,		//-2
			0x08,0x20,		//-1
			0x08,0x3E,		//Center
			0x08,0x20,		//+1
			0x04,0x40,		//+2
			0x03,0x80		//+3
		},
		
		{
			// Negtative B
			16,0,			//XTCY
			15,0,			//YTCY
			0,   0,			//6
			0,   0,			//7
			0,   0,			//8
			0,   0,			//9
			0x38,0,			//0 PartEdge
			0x44,0,			//1
			0x82,0,			//2
			0x82,0,			//3
			0x82,0,			//4
			0x44,0,			//5
			0x38,0,			//6
			0x10,0,			//7
			0x10,0,			//8
			0x10,0,			//9
			0x10,0			//0 PinEnd
		}
	},


	{  //******  N E G A T I V E   C L O C K *****
		{
			// NegtativeClocl L
			16,0,			//XTCY
			7,0,			//YTCY
			0x03,0xB0,		//-3
			0x04,0x68,		//-2
			0x08,0x24,		//-1
			0xF8,0x22,		//Center
			0x08,0x24,		//+1
			0x04,0x68,		//+2
			0x03,0xB0		//+3
		},
	
		{
			// NegtativeClock T
			16,0,			//XTCY
			15,0,			//YTCY
			0x10,0,			//0 PinEnd
			0x10,0,			//1
			0x10,0,			//2
			0x10,0,			//3
			0x38,0,			//4
			0x44,0,			//5
			0x82,0,			//6
			0x82,0,			//7
			0x82,0,			//8
			0x44,0,			//9 
			0xFE,0,			//0 PartEdge
			0x82,0,			//1
			0x44,0,			//2
			0x28,0,			//3
			0x10,0			//4
		},
		
		{
			// NegtativeClock R
			16,0,			//XTCY
			7,0,			//YTCY
			0x1B,0x80,		//-3
			0x2C,0x40,		//-2
			0x48,0x20,		//-1
			0x88,0x3E,		//Center
			0x48,0x20,		//+1
			0x2C,0x40,		//+2
			0x1B,0x80		//+3
		},
		
		{
			// NegtativeClock B
			16,0,			//XTCY
			15,0,			//YTCY
			0x10,0,			//6
			0x28,0,			//7
			0x44,0,			//8
			0x82,0,			//9
			0xFE,0,			//0 PartEdge
			0x44,0,			//1
			0x82,0,			//2
			0x82,0,			//3
			0x82,0,			//4
			0x44,0,			//5
			0x38,0,			//6
			0x10,0,			//7
			0x10,0,			//8
			0x10,0,			//9
			0x10,0			//0 PinEnd
		}
	}
};


//i̕`
void CPartView::DrawBody(CDC* pDC,LPRECT prc)
{
	if(!m_pPartInfo)return;

	BOOL bUseLocalDC=FALSE;
	if(!pDC){
		bUseLocalDC=TRUE;
		pDC=new CClientDC(this);
		PrepareDC(pDC);
	}
	

	int cx,cy,l,t,r,b;
	l=t=PART_MARGIN;

	COLORREF col=COL_PART;
	
	//`̕`
	//p^[݂Ȃꍇ͋``
	if(m_pPartInfo->m_pPtn==NULL){
		cx=m_pPartInfo->m_size.cx*10;
		cy=m_pPartInfo->m_size.cy*10;
		r=l+cx;
		b=t+cy;
	
		CPen* pNewPen=new CPen(PS_SOLID,1,col);
		CPen* pOldPen=pDC->SelectObject(pNewPen);
	
		pDC->MoveTo(l,t);
		pDC->LineTo(l,b);
		pDC->LineTo(r,b);
		pDC->LineTo(r,t);
		pDC->LineTo(l,t);
		pDC->SelectObject(pOldPen);					//y̕A
		delete pNewPen;

	}else{	//p^[
		if(m_pPartInfo->m_pPtn->m_pBuff){
			CBitmap* pBmp	=new CBitmap;	//rbg}bvIuWFNg̍쐬
			CDC* pMemDC		=new CDC;		//foCXReLXgIuWFNg̍쐬
	
			cx=m_pPartInfo->m_pPtn->m_size.cx;
			cy=m_pPartInfo->m_pPtn->m_size.cy;

			//p^[rbg}bv
			pMemDC->CreateCompatibleDC(pDC);//foCXReLXg̍쐬
			pBmp->CreateBitmap(cx,cy,1,1,m_pPartInfo->m_pPtn->m_pBuff);
			CBitmap* pOldBmp=pMemDC->SelectObject(pBmp);//rbg}bv̑I
	
			CBrush* pNewBrush=new CBrush(col);
			CBrush* pOldBrush=pDC->SelectObject(pNewBrush);
			pDC->BitBlt(l,t,cx,cy,pMemDC,0,0,0x0000E20746);
				// 00E20746	DSPDxax
				// [P]   1   1   1   1   0   0   0   0
				// [S]   1   1   0   0   1   1   0   0
				// [D]   1   0   1   0   1   0   1   0
				// -------------------------------------
				//       1   1   1   0   0   0   1   0  ----> 0xE2
			pDC->SelectObject(pOldBrush);
			delete pNewBrush;

			pMemDC->SelectObject(pOldBmp);
			delete pMemDC;
			delete pBmp;
		}
	}

	if(bUseLocalDC) delete pDC;
}


BOOL g_RectAndRect(LPCRECT lprc0,LPCRECT lprc1)
{
	//ŏdȂĂȂ̂nl
	if(lprc0->left <= lprc1->left){				// 0: L---------R
		if(lprc0->right < lprc1->left)return 0;	// 1:				 L-------R
    }else{
    	if(lprc1->right < lprc0->left)return 0; // 0:                L-------R
	}											// 1: L---------R
	//ŏdȂĂȂ̂nl
	if(lprc0->top <= lprc1->top){				// 0: T---------B
		if(lprc0->bottom < lprc1->top)return 0;	// 1:				 T-------B
    }else{
    	if(lprc1->bottom < lprc0->top)return 0;	// 0:                T-------B
	}											// 1: T---------B
	//cdȂĂB
	return 1;
}



static int s_CStrToPinStr(LPCSTR pCStr,BYTE* pPinStr)
{
	BOOL bUpper=FALSE;
	int n=0;
	while(*pCStr){
		if(bUpper){
			*pPinStr=(*pCStr)|0x80;
			pPinStr++;pCStr++;n++;
			bUpper=FALSE;
		}else if(*pCStr=='\\'){
			bUpper=TRUE;
			pCStr++;
		}else{
			*pPinStr=*pCStr;
			pPinStr++;pCStr++;n++;
		}
		if(n==255) break;
	}
	*pPinStr=0;
	return n;
}


#define PIN_UPPER	(10)
#define PIN_LOWER	(5)
#define PIN_OUTSIDE	(50)
#define PIN_INSIDE	(8*32+5)

//ws̍ĕ`
// : s̕񒷂32ƌ߂ĂB
void CPartView::ReDrawPin(int nLTRB,int nOffset)
{
	if(!m_pPartInfo) return;
	//CLCoPin* pPin;
	CRect rc;
	switch(nLTRB){
	case 0:
		rc.left=	PART_MARGIN-PIN_OUTSIDE;
		rc.top=		PART_MARGIN+nOffset*10-PIN_UPPER;
		rc.right=	PART_MARGIN+PIN_INSIDE;
		rc.bottom=	PART_MARGIN+nOffset*10+PIN_LOWER;
	
		break;
	case 1:
		rc.left=	PART_MARGIN+nOffset*10-PIN_UPPER;
		rc.top=		PART_MARGIN-PIN_OUTSIDE;
		rc.right=	PART_MARGIN+nOffset*10+PIN_LOWER;
		rc.bottom=	PART_MARGIN+PIN_INSIDE;
		break;
	case 2:
		rc.left=	PART_MARGIN+m_pPartInfo->m_size.cx*10-PIN_INSIDE;
		rc.top=		PART_MARGIN+nOffset*10-PIN_UPPER;
		rc.right=	PART_MARGIN+m_pPartInfo->m_size.cx*10+PIN_OUTSIDE;
		rc.bottom=	PART_MARGIN+nOffset*10+PIN_LOWER;
		break;
	default:
		rc.left=	PART_MARGIN+nOffset*10-PIN_UPPER;
		rc.top=		PART_MARGIN+m_pPartInfo->m_size.cy*10-PIN_INSIDE;
		rc.right=	PART_MARGIN+nOffset*10+PIN_LOWER;
		rc.bottom=	PART_MARGIN+m_pPartInfo->m_size.cy*10+PIN_OUTSIDE;
		break;
	}
	CClientDC dc(this);
	PrepareDC(&dc);
	dc.LPtoDP(&rc);
	InvalidateRect(&rc);
}


//s̕`
void CPartView::DrawPin(CDC* pDC,LPRECT prc,CLCoPin* pPin)	
{
	COLORREF col;
	CPoint ptPin;
	BYTE szPinName[256];
	int cx,cy;

	if(!pPin) return;

	switch(pPin->m_nLTRB){
	case 0:
		ptPin.x=PART_MARGIN;
		ptPin.y=PART_MARGIN+pPin->m_nOffset*10;
		break;
	case 1:
		ptPin.x=PART_MARGIN+pPin->m_nOffset*10;
		ptPin.y=PART_MARGIN;
		break;
	case 2:
		ptPin.x=PART_MARGIN+m_pPartInfo->m_size.cx*10;
		ptPin.y=PART_MARGIN+pPin->m_nOffset*10;
		break;
	default:
		ptPin.x=PART_MARGIN+pPin->m_nOffset*10;
		ptPin.y=PART_MARGIN+m_pPartInfo->m_size.cy*10;
		break;
	}

	int nNameLen=s_CStrToPinStr(pPin->m_strName,szPinName);


	if(prc){
		int nInside=nNameLen*8+5;
		CRect rc;
		switch(pPin->m_nLTRB){
		case 0:
			rc.left=	ptPin.x-PIN_OUTSIDE;
			rc.top=		ptPin.y-PIN_UPPER;
			rc.right=	ptPin.x+nInside;
			rc.bottom=	ptPin.y+PIN_LOWER;
			break;
		case 1:
			rc.left=	ptPin.x-PIN_UPPER;
			rc.top=		ptPin.y-PIN_OUTSIDE;
			rc.right=	ptPin.x+PIN_LOWER;
			rc.bottom=	ptPin.y+nInside;
			break;
		case 2:
			rc.left=	ptPin.x-nInside;
			rc.top=		ptPin.y-PIN_UPPER;
			rc.right=	ptPin.x+PIN_OUTSIDE;
			rc.bottom=	ptPin.y+PIN_LOWER;
			break;
		default:
			rc.left=	ptPin.x-PIN_UPPER;
			rc.top=		ptPin.y-nInside;
			rc.right=	ptPin.x+PIN_LOWER;
			rc.bottom=	ptPin.y+PIN_OUTSIDE;
			break;
		}

		//dȂ̃`FbN
		if(!g_RectAndRect(&rc,prc)){
			return;
		}
	}

//	#define PIN_TYPE_SMALL		0x00000001

	CPoint pt0;
	
	col=RGB(0,0,0);
	if(pPin->m_nType & (PIN_TYPE_CLOCK | PIN_TYPE_NEGATIVE)){
		int nPinType;
		switch(pPin->m_nType & (PIN_TYPE_CLOCK | PIN_TYPE_NEGATIVE)){
		case PIN_TYPE_CLOCK:	nPinType=0; break;
		case PIN_TYPE_NEGATIVE:	nPinType=1; break;
		default:				nPinType=2; break;
		}
		pt0=ptPin;
		switch(pPin->m_nLTRB){
		case 0:	pt0.x-=10; pt0.y-=3;			break;
		case 1: pt0.x-=3;  pt0.y-=10;			break;
		case 2: pt0.x-=4;  pt0.y-=3;			break;	
		default:pt0.x-=3;  pt0.y-=4;			break;
		}

		BYTE* pPtnBuff=PinPtn[nPinType][pPin->m_nLTRB];
		cx=*((WORD*)(pPtnBuff));
		cy=*((WORD*)(pPtnBuff+2));
		pPtnBuff+=4;


		CBitmap* pBmp	=new CBitmap;	//rbg}bvIuWFNg̍쐬
		CDC* pMemDC		=new CDC;		//foCXReLXgIuWFNg̍쐬
	
		//p^[rbg}bv
		pMemDC->CreateCompatibleDC(pDC);//foCXReLXg̍쐬
		pBmp->CreateBitmap(cx,cy,1,1,pPtnBuff);
		CBitmap* pOldBmp=pMemDC->SelectObject(pBmp);//rbg}bv̑I
	
		CBrush* pNewBrush=new CBrush(col);
		CBrush* pOldBrush=pDC->SelectObject(pNewBrush);
		pDC->BitBlt(pt0.x,pt0.y,cx,cy,pMemDC,0,0,0x00E20746);
			// 00E20746	DSPDxax
			// [P]   1   1   1   1   0   0   0   0
			// [S]   1   1   0   0   1   1   0   0
			// [D]   1   0   1   0   1   0   1   0
			// -------------------------------------
			//       1   1   1   0   0   0   1   0  ----> 0xE2
		pDC->SelectObject(pOldBrush);
		delete pNewBrush;
		pMemDC->SelectObject(pOldBmp);
		delete pMemDC;
		delete pBmp;
	}else{
		CPen* pNewPen=new CPen(PS_SOLID,1,col);
		CPen* pOldPen;
		//pt0̐ݒ
		pt0=ptPin;
		switch(pPin->m_nLTRB){
		case 0:	pt0.x-=10;	break;
		case 1: pt0.y-=10;	break;
		case 2: pt0.x+=10;	break;	
		default:pt0.y+=10;	break;
		}
		pOldPen=pDC->SelectObject(pNewPen);			//쐬y̑I
		pDC->MoveTo(pt0);
		pDC->LineTo(ptPin);
		pDC->SelectObject(pOldPen);					//y̕A
		delete pNewPen;
	}

	BOOL bPointFront;	//wW̑ÔƂTRUE
	BOOL bVert;			//̂ƂTRUE;
	col=RGB(0,0,255);

	//s̕`
	if(szPinName[0]!=0){
//		if(dwMode & DRAW_XOR) col=COL_XOR; else col=COL_PART_PINNAME;
		pt0=ptPin;		//ptPin̍WPutFont
		switch(pPin->m_nLTRB){
		case 0:
			bPointFront=TRUE;
			bVert      =FALSE;
			pt0.x+=5;
			pt0.y+=4;
			break;
		case 1:
			bPointFront=FALSE;
			bVert      =TRUE;
			pt0.x+=4;
			pt0.y+=5;
			break;
		case 2:
			bPointFront=FALSE;
			bVert      =FALSE;
			pt0.x-=5;
			pt0.y+=4;
			break;
		default:
			bPointFront=TRUE;
			bVert      =TRUE;
			pt0.x+=4;
			pt0.y-=5;
			break;
		}
		g_LCoFont.PutFont(pDC,pt0.x,pt0.y,(LPCSTR)szPinName,nNameLen,col,
						DRAW_ON,bVert,bPointFront);
	}
	
	//DWORD dwPinNum=pPin->m_pdwNum[m_nSelectBlock];
	//if(dwPinNum& 0x8000) col=RGB(255,0,0);

	//if(pPin->m_pstrPinNum[m_nSelectBlock][0]=='H') col=RGB(255,0,0);
	if(pPin->m_pstrPinNum[0][0]=='H') col=RGB(255,0,0);

	
//	char szPinNum[16];
//	char* pc=szPinNum;
//	if(dwPinNum & 0x7C00)	*pc++=(char)((((dwPinNum & 0x7C00)>>10)+'A'-1)&0x7F);
//	_itoa(dwPinNum & 0x1FF,pc,10);
	CString strPinNum;
	if(pPin->m_pstrPinNum[m_nSelectBlock][0]=='\0'){
		strPinNum="";
	}else{
		strPinNum=pPin->m_pstrPinNum[m_nSelectBlock].Mid(1);
	}

	int nPinOffset;
	if(pPin->m_nType & PIN_TYPE_SMALL) nPinOffset=2; else nPinOffset=8;
	pt0=ptPin;		//ptPin̍WPutFont
	switch(pPin->m_nLTRB){
	case 0:
		bPointFront=FALSE;
		bVert      =FALSE;
		pt0.x-=nPinOffset;
		pt0.y-=2;
		break;
	case 1:
		bPointFront=TRUE;
		bVert      =TRUE;
		pt0.x-=2;
		pt0.y-=nPinOffset;
		break;
	case 2:
		bPointFront=TRUE;
		bVert      =FALSE;
		pt0.x+=nPinOffset;
		pt0.y-=2;
		break;
	default:
		bPointFront=FALSE;
		bVert      =TRUE;
		pt0.x-=2;
		pt0.y+=nPinOffset;
		break;
	}
	g_LCoFont.PutFont(pDC,pt0.x,pt0.y,strPinNum,-1,
			             col,DRAW_ON,bVert,bPointFront);

}

