// PEditor.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "lco.h"
#include "PartInfo.h"
#include "PEditor.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define PTNEDIT_MARGIN 20
#define PTNEDIT_ZOOMIN 5

#define L_CAPTURE	1
#define R_CAPTURE	2


/////////////////////////////////////////////////////////////////////////////
// CPEditor

CPEditor::CPEditor()
{
	m_pointWindowOrg=CPoint(0,0);
	m_sizeClient=CSize(0,0);
	m_sizeView=CSize(0,0);
	m_pPtn=NULL;
	m_nZoomMulti=PTNEDIT_ZOOMIN;
	m_nOnCapture=0;
	m_nTool=0;
	m_bDrawSelectRect=FALSE;
	m_bDrawTemp=FALSE;
	m_pTempPtn=NULL;
	m_bChange=FALSE;
	m_pUndoBuff=NULL;
	m_bCanUndo=FALSE;
}

CPEditor::~CPEditor()
{
	delete[]m_pUndoBuff;
}


BEGIN_MESSAGE_MAP(CPEditor, CWnd)
	//{{AFX_MSG_MAP(CPEditor)
	ON_WM_SIZE()
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_SETCURSOR()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CPEditor bZ[W nh

void CPEditor::OnSize(UINT nType, int cx, int cy) 
{
	CWnd::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	m_sizeClient.cx=cx;
	m_sizeClient.cy=cy;

	SCROLLINFO si;
	si.fMask=SIF_RANGE|SIF_POS|SIF_PAGE;
	int nPos;

//	if(m_nTool==0 && m_pTempPtn) DrawTempPtn(NULL,NULL);

	nPos=m_pointWindowOrg.y;
	if(nPos>(m_sizeView.cy-m_sizeClient.cy))nPos=m_sizeView.cy-m_sizeClient.cy;
	if(nPos<0) nPos=0;
	si.nMin=0;
	si.nMax=m_sizeView.cy;
	si.nPage=m_sizeClient.cy;
	si.nPos =nPos;
	m_pointWindowOrg.y=nPos;
	SetScrollInfo(SB_VERT,&si,TRUE);

	nPos=m_pointWindowOrg.x;
	if(nPos>(m_sizeView.cx-m_sizeClient.cx))nPos=m_sizeView.cx-m_sizeClient.cx;
	if(nPos<0) nPos=0;
	si.nMin=0;
	si.nMax=m_sizeView.cx;
	si.nPage=m_sizeClient.cx;
	si.nPos =nPos;
	m_pointWindowOrg.x=nPos;
	SetScrollInfo(SB_HORZ,&si,TRUE);

}


//wItZbgԂ̐XN[ XN[ TRUE Ԃ
BOOL CPEditor::VScrollOffset(int nOffset)
{
	SCROLLINFO si;
	GetScrollInfo(SB_VERT,&si);
	int nCurrentPos=si.nPos;
	int nNewPos=nCurrentPos+nOffset;

	if(nNewPos<0)nNewPos=0;
	else if(nNewPos>si.nMax-(int)si.nPage+1) nNewPos=si.nMax-si.nPage+1;
	if(nCurrentPos!=nNewPos){
		if(m_nTool==0 && m_pTempPtn){
			m_bDrawSelectRect=FALSE;
			DrawSelectRect(NULL);
		}
		si.nPos=m_pointWindowOrg.y=nNewPos;
		ScrollWindow(0,nCurrentPos-nNewPos);
		si.fMask=SIF_RANGE|SIF_POS|SIF_PAGE;
		SetScrollInfo(SB_VERT,&si);
		UpdateWindow();

		if(m_nTool==0 && m_pTempPtn){
			m_bDrawSelectRect=TRUE;
			DrawSelectRect(NULL);
		}

		return TRUE;
	}
	return FALSE;
}

//wItZbgԂ̐XN[ XN[ TRUE Ԃ
BOOL CPEditor::HScrollOffset(int nOffset)
{
	SCROLLINFO si;
	GetScrollInfo(SB_HORZ,&si);
	int nCurrentPos=si.nPos;
	int nNewPos=nCurrentPos+nOffset;

	if(nNewPos<0)nNewPos=0;
	else if(nNewPos>si.nMax-(int)si.nPage+1) nNewPos=si.nMax-si.nPage+1;
	if(nCurrentPos!=nNewPos){
		if(m_nTool==0 && m_pTempPtn){
			m_bDrawSelectRect=FALSE;
			DrawSelectRect(NULL);
		}
		si.nPos=m_pointWindowOrg.x=nNewPos;
	
		ScrollWindow(nCurrentPos-nNewPos,0);
		si.fMask=SIF_RANGE|SIF_POS|SIF_PAGE;
		SetScrollInfo(SB_HORZ,&si);
		UpdateWindow();

		if(m_nTool==0 && m_pTempPtn){
			m_bDrawSelectRect=TRUE;
			DrawSelectRect(NULL);
		}
		return TRUE;
	}
	return FALSE;
}

//XN[bZ[Wnh
void CPEditor::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	SetFocus();
	int nOffset;
	switch(nSBCode){
	case SB_THUMBTRACK:
	case SB_THUMBPOSITION:
		nOffset=nPos-m_pointWindowOrg.x;
		break;
	case SB_LINEUP:
		nOffset=-20;
		break;
	case SB_LINEDOWN:
		nOffset=+20;
		break;
	case SB_PAGEUP:
		nOffset=-100;
		break;
	case SB_PAGEDOWN:
		nOffset=+100;
		break;
	default:
		return;
	}
	HScrollOffset(nOffset);
	//CWnd::OnHScroll(nSBCode, nPos, pScrollBar);
}


//XN[nh
void CPEditor::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
		SetFocus();
	int nOffset;
	switch(nSBCode){
	case SB_THUMBTRACK:
	case SB_THUMBPOSITION:
		nOffset=nPos-m_pointWindowOrg.y;
		break;
	case SB_LINEUP:
		nOffset=-20;
		break;
	case SB_LINEDOWN:
		nOffset=+20;
		break;
	case SB_PAGEUP:
		nOffset=-100;
		break;
	case SB_PAGEDOWN:
		nOffset=+100;
		break;
	default:
		return;
	}
	VScrollOffset(nOffset);
	//CWnd::OnVScroll(nSBCode, nPos, pScrollBar);
}


//p^[̃|C^̐ݒ
void CPEditor::SetPtnPtr(CLCoPtn* pPtn)
{

	FixTemp();	//Vp^[̃|C^ݒ肷OɈꎞp^[FIX 1997/11/02

	m_pointWindowOrg=CPoint(0,0);
	delete[]m_pUndoBuff;
	m_pUndoBuff=NULL;

	if(!pPtn){
		m_sizeView=CSize(0,0);
		m_pPtn=NULL;
	}else{
		m_pPtn=pPtn;
		m_sizeView.cx=PTNEDIT_MARGIN*2 + pPtn->m_size.cx*m_nZoomMulti;
		m_sizeView.cy=PTNEDIT_MARGIN*2 + pPtn->m_size.cy*m_nZoomMulti;

		int x,y,buffsize;
		x=m_pPtn->m_size.cx;
		y=m_pPtn->m_size.cy;
		buffsize=((x+15)/16)*2*y;
		m_pUndoBuff=new BYTE[buffsize];
	}
	Resize();
	Invalidate();
}

//Y[C
void CPEditor::ZoomIn()
{
	if(m_nZoomMulti>1) return;
	m_nZoomMulti=PTNEDIT_ZOOMIN;
	if(!m_pPtn) return;
	m_sizeView.cx=PTNEDIT_MARGIN*2 + m_pPtn->m_size.cx*m_nZoomMulti;
	m_sizeView.cy=PTNEDIT_MARGIN*2 + m_pPtn->m_size.cy*m_nZoomMulti;
	Resize();
	Invalidate();
}

//Y[AEg
void CPEditor::ZoomOut()
{
	if(m_nZoomMulti==1) return;
	m_nZoomMulti=1;
	if(!m_pPtn) return;
	m_sizeView.cx=PTNEDIT_MARGIN*2 + m_pPtn->m_size.cx*m_nZoomMulti;
	m_sizeView.cy=PTNEDIT_MARGIN*2 + m_pPtn->m_size.cy*m_nZoomMulti;
	Resize();
	Invalidate();
}

//c[̃Zbg
//0:ZN^
//1:y
//2:
//3:~
void CPEditor::SetTool(int nTool)
{
	m_nTool=nTool;
	m_bDrawSelectRect=FALSE;
	if(FixTemp()) Invalidate();
}


//WM_SIZE𑗂
void CPEditor::Resize()
{
	CRect rc;
	SendMessage(WM_SIZE,0,MAKELONG(m_sizeClient.cx,m_sizeClient.cy));
}

//WindowOrg̐ݒ
void CPEditor::PrepareDC(CDC* pDC)
{
	pDC->SetWindowOrg(m_pointWindowOrg);
}


void CPEditor::OnPaint() 
{
	CPaintDC dc(this); // `p̃foCX ReLXg
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	
	// `pbZ[WƂ CWnd::OnPaint() ĂяoĂ͂܂
	if(!m_pPtn) return;
	PrepareDC(&dc);					//WindowOrg̐ݒ
	CRect rcDraw=dc.m_ps.rcPaint;	//``𓾂
	dc.DPtoLP(&rcDraw);				//WindowOrg̐ݒ𔽉f

	DrawPtn(&dc,&rcDraw);			//p^[̕`
	DrawBack(&dc,&rcDraw);		//wi̕`
	DrawTempPtn(&dc,&rcDraw);		//ꎞp^[̕`
	if(m_bDrawSelectRect){
		TRACE("OnPaint DrawSelectRect\n");
		DrawSelectRect(&dc);
	}
}

//wi̕`
void CPEditor::DrawBack(CDC* pDC,LPRECT prc)
{
	if(!m_pPtn) return;

	BOOL bUseLocalDC=FALSE;
	if(!pDC){
		bUseLocalDC=TRUE;
		pDC=new CClientDC(this);
		PrepareDC(pDC);
	}
	CRect rcDraw;
	if(prc) rcDraw=*prc;
	else rcDraw=CRect(0,0,m_sizeView.cx,m_sizeView.cy);

	int l,t,r,b;
	l=t=PTNEDIT_MARGIN;
	r=l+m_pPtn->m_size.cx*m_nZoomMulti;
	b=t+m_pPtn->m_size.cy*m_nZoomMulti;


	int n,m;
	
	if(m_nZoomMulti==1){
		r--;
		b--;
		CPen pen(PS_SOLID,1,RGB(0,0,255));
		CPen* pPenOld=pDC->SelectObject(&pen);

		//c̉s̕`
		if(rcDraw.left<l && rcDraw.right>l-10){	
			if(t<rcDraw.top) n=rcDraw.top; else n=t;
			n=((n+9)/10)*10;
			if(b>rcDraw.bottom) m=rcDraw.bottom; else m=b;
			while(n<=m){
				pDC->MoveTo(l-10,n);
				pDC->LineTo(l,n);
				n+=10;
			}
		}
		//Ec̉s̕`
		if(rcDraw.left<r+10 && rcDraw.right>r){	
			if(t<rcDraw.top) n=rcDraw.top; else n=t;
			n=((n+9)/10)*10;
			if(b>rcDraw.bottom) m=rcDraw.bottom; else m=b;
			while(n<=m){
				pDC->MoveTo(r+10,n);
				pDC->LineTo(r,n);
				n+=10;
			}
		}
		//㉡̉s̕`
		if(rcDraw.top<t && rcDraw.bottom>t-10){	
			if(l<rcDraw.left) n=rcDraw.left; else n=l;
			n=((n+9)/10)*10;
			if(r>rcDraw.right) m=rcDraw.right; else m=r;
			while(n<=m){
				pDC->MoveTo(n,t-10);
				pDC->LineTo(n,t);
				n+=10;
			}
		}
		//̉s̕`
		if(rcDraw.top<b+10 && rcDraw.bottom>b){	
			if(l<rcDraw.left) n=rcDraw.left; else n=l;
			n=((n+9)/10)*10;
			if(r>rcDraw.right) m=rcDraw.right; else m=r;
			while(n<=m){
				pDC->MoveTo(n,b+10);
				pDC->LineTo(n,b);
				n+=10;
			}
		}
		pDC->SelectObject(pPenOld);
	}else{
		CPen penGray(PS_SOLID,1,RGB(192,192,192));
		CPen penBlue(PS_SOLID,1,RGB(0,0,255));
		CPen* pPenOld=pDC->SelectObject(&penGray);

		if(rcDraw.left  >l) l=rcDraw.left;
		if(rcDraw.top   >t) t=rcDraw.top;
		if(rcDraw.right <r) r=rcDraw.right;
		if(rcDraw.bottom<b) b=rcDraw.bottom;

		int n,m;
		//̕`
		if(l<=r){
			m=(t-PTNEDIT_MARGIN+(m_nZoomMulti-1))/m_nZoomMulti;
			n=PTNEDIT_MARGIN+m*m_nZoomMulti;
			m%=10;
			while(n<=b){
				if(m==0 || m==1){
					CPen* pPenOld=pDC->SelectObject(&penBlue);
				}else{
					CPen* pPenOld=pDC->SelectObject(&penGray);
				}
				pDC->MoveTo(l,n);
				pDC->LineTo(r+1,n);
				m++;
				if(m>9)m=0;
				n+=m_nZoomMulti;
			}
		}
		//̕`
		if(t<=b){
			m=(l-PTNEDIT_MARGIN+(m_nZoomMulti-1))/m_nZoomMulti;
			n=PTNEDIT_MARGIN+m*m_nZoomMulti;
			m%=10;
			while(n<=r){
				if(m==0 || m==1){
					CPen* pPenOld=pDC->SelectObject(&penBlue);
				}else{
					CPen* pPenOld=pDC->SelectObject(&penGray);
				}
				pDC->MoveTo(n,t);
				pDC->LineTo(n,b);
				m++;
				if(m>9)m=0;
				n+=m_nZoomMulti;
			}
		}
		pDC->SelectObject(pPenOld);
	}
		

	if(bUseLocalDC) delete pDC;
}

//p^[̍WEBhE̘_Wɕϊ
void CPEditor::PtnPtoLP(CPoint* ppt)
{
	ppt->x=ppt->x*m_nZoomMulti+m_nZoomMulti/2+PTNEDIT_MARGIN;
	ppt->y=ppt->y*m_nZoomMulti+m_nZoomMulti/2+PTNEDIT_MARGIN;
}

//EBhE̘_Wp^[̍Wɕϊ
BOOL CPEditor::LPtoPtnP(CPoint* ppt)
{
	BOOL bResult=TRUE;

	ppt->x=(ppt->x-PTNEDIT_MARGIN)/m_nZoomMulti;
	ppt->y=(ppt->y-PTNEDIT_MARGIN)/m_nZoomMulti;
	if(ppt->x<0 || !m_pPtn){
		bResult=FALSE;
		ppt->x=0;
	}else if(ppt->x >= m_pPtn->m_size.cx){
		bResult=FALSE;
		ppt->x=m_pPtn->m_size.cx-1;
	}
	if(ppt->y<0 || !m_pPtn){
		bResult=FALSE;
		ppt->y=0;
	}else if(ppt->y >= m_pPtn->m_size.cy){
		bResult=FALSE;
		ppt->y=m_pPtn->m_size.cy-1;
	}
	return bResult;
}



//p^[̕`
void CPEditor::DrawPtn(CDC* pDC,LPRECT prc)
{
	if(!m_pPtn)return;

	BOOL bUseLocalDC=FALSE;
	if(!pDC){
		bUseLocalDC=TRUE;
		pDC=new CClientDC(this);
		PrepareDC(pDC);
	}
	

	int cx,cy,l,t;
	l=t=PTNEDIT_MARGIN;


	if(m_pPtn->m_pBuff){
		CBitmap* pBmp	=new CBitmap;	//rbg}bvIuWFNg̍쐬
		CDC* pMemDC		=new CDC;		//foCXReLXgIuWFNg̍쐬
	
		cx=m_pPtn->m_size.cx;
		cy=m_pPtn->m_size.cy;

		//p^[rbg}bv
		pMemDC->CreateCompatibleDC(pDC);//foCXReLXg̍쐬
		pBmp->CreateBitmap(cx,cy,1,1,m_pPtn->m_pBuff);
		CBitmap* pOldBmp=pMemDC->SelectObject(pBmp);//rbg}bv̑I
	
		pDC->SetTextColor(RGB(255,255,255));
		pDC->SetBkColor(RGB(0,0,0));

		pDC->StretchBlt(l,t,cx*m_nZoomMulti,cy*m_nZoomMulti,
			pMemDC,0,0,cx,cy,SRCCOPY);

		pMemDC->SelectObject(pOldBmp);
		delete pMemDC;
		delete pBmp;
	}
	if(bUseLocalDC) delete pDC;
}


//ppt  CPoint arrayPt[8]ւ̃|C^
//QluCɂASYTv(F Zp]_Ёj
BOOL CPEditor::GetCirclePoint(CPoint* ppt,BOOL bInit)
{
	static int nXCenter;
	static int nYCenter;
	static int nXRadius;
	static int nYRadius;
	static int nLargeRadius;
	static int nx,ny,nr;
	static int nXOdd,nYOdd;
	//aꍇ̃e[u
	static const int nLimitTable[8]={1,1,2,3,4,4,5,5};
	static const int nXTable[8][5]={
		//a 0
		{ 0	},
		//a 1
		{ 0	},
		//a 2
		{ 2,2 },
		//a 3
		{ 3,3,2 },
		//a 4
		{ 4,4,4,3 },
		//a 5
		{ 5,5,5,4 },
		//a 6
		{ 6,6,6,5,4 },
		//a 7
		{ 7,7,7,6,5 }
	};

	int nx1,ny1;

	if(bInit){
		int x,y,r,b;
		if(m_ptEnd.x>m_ptStart.x) r=m_ptEnd.x; else r=m_ptStart.x;
		if(m_ptEnd.y>m_ptStart.y) b=m_ptEnd.y; else b=m_ptStart.y;
		x=m_ptEnd.x+m_ptStart.x;
		y=m_ptEnd.y+m_ptStart.y;
		nXCenter=x/2;
		nYCenter=y/2;
		nXOdd=x&1;
		nYOdd=y&1;
		nXRadius=r-nXCenter;
		nYRadius=b-nYCenter;
		if(nXRadius>nYRadius) nLargeRadius=nXRadius; else nLargeRadius=nYRadius;
		nx=nr=nLargeRadius;
		ny=0;
	}

	if(nXRadius>nYRadius){
		nx1=nx * nYRadius / nXRadius;
		ny1=ny * nYRadius / nXRadius;
		ppt[0].x=nXCenter+nx;			ppt[0].y=nYCenter+ny1;
		ppt[1].x=nXCenter+nx;			ppt[1].y=nYCenter-ny1+nYOdd;
		ppt[2].x=nXCenter-nx+nXOdd;		ppt[2].y=nYCenter+ny1;
		ppt[3].x=nXCenter-nx+nXOdd;		ppt[3].y=nYCenter-ny1+nYOdd;
		ppt[4].x=nXCenter+ny;			ppt[4].y=nYCenter+nx1;
		ppt[5].x=nXCenter+ny;			ppt[5].y=nYCenter-nx1+nYOdd;
		ppt[6].x=nXCenter-ny+nXOdd;		ppt[6].y=nYCenter+nx1;
		ppt[7].x=nXCenter-ny+nXOdd;		ppt[7].y=nYCenter-nx1+nYOdd;
	}else{
		if(nYRadius==0){
			nx1=nx;
			ny1=ny;
		}else{
			nx1=nx * nXRadius / nYRadius;
			ny1=ny * nXRadius / nYRadius;
		}
		ppt[0].x=nXCenter+nx1;			ppt[0].y=nYCenter+ny;
		ppt[1].x=nXCenter+nx1;			ppt[1].y=nYCenter-ny+nYOdd;
		ppt[2].x=nXCenter-nx1+nXOdd;	ppt[2].y=nYCenter+ny;
		ppt[3].x=nXCenter-nx1+nXOdd;	ppt[3].y=nYCenter-ny+nYOdd;
		ppt[4].x=nXCenter+ny1;			ppt[4].y=nYCenter+nx;
		ppt[5].x=nXCenter+ny1;			ppt[5].y=nYCenter-nx+nYOdd;
		ppt[6].x=nXCenter-ny1+nXOdd;	ppt[6].y=nYCenter+nx;
		ppt[7].x=nXCenter-ny1+nXOdd;	ppt[7].y=nYCenter-nx+nYOdd;
	}
	if(nLargeRadius<8){
		ny++;
		if(ny>=nLimitTable[nLargeRadius])return FALSE;
		nx=nXTable[nLargeRadius][ny];
		return TRUE;
	}else{
		if((nr -=(ny++ << 1) -1)<0)
			nr += (nx-- -1)<<1;
		if(nx<ny)	return FALSE;
		return TRUE;
	}
}



BOOL CPEditor::GetLinePoint(CPoint* ppt,BOOL bInit)
{
	static int nDx;
	static int nDy;
	static int nP;
	static BOOL bDxIsLarge;
	static int nH;

	if(bInit){
		nDx=m_ptEnd.x-m_ptStart.x;
		nDy=m_ptEnd.y-m_ptStart.y;
		if(abs(nDx)>abs(nDy)){
			nP=m_ptStart.x;
			bDxIsLarge=TRUE;
			nH=nDx/2;
			if(nDy<0) nH=-nH;

		}else{
			nP=m_ptStart.y;
			bDxIsLarge=FALSE;
			nH=nDy/2;
			if(nDx<0) nH=-nH;
		}
	}

	if(bDxIsLarge){
		ppt->x=nP;
		ppt->y=m_ptStart.y+(nDy*(nP-m_ptStart.x)+nH)/nDx;
		if(nP==m_ptEnd.x) return FALSE;
		if(nDx>0)nP++;
		else nP--;
		return TRUE;
	}else{
		ppt->y=nP;
		if(nDy==0) ppt->x=m_ptStart.x;
		else ppt->x=m_ptStart.x+(nDx*(nP-m_ptStart.y)+nH)/nDy;
		if(nP==m_ptEnd.y) return FALSE;
		if(nDy>0)nP++;
		else nP--;
		return TRUE;
	}
}



//ꎞ̕`
void CPEditor::DrawTempLine(CDC* pDC)
{
	BOOL bUseLocalDC=FALSE;
	if(!pDC){
		bUseLocalDC=TRUE;
		pDC=new CClientDC(this);
		PrepareDC(pDC);
	}
	CPoint pt;

	int nXByte=((m_pTempPtn->m_size.cx+15)/16)*2;	//obt@XoCg
	int nBuffsize=nXByte*m_pTempPtn->m_size.cy;	//obt@̃TCY
	int n;
	BYTE* pb=m_pTempPtn->m_pBuff;
	for(n=0;n<nBuffsize;n++) *pb++=0;


	n=0;
	BOOL bNext=GetLinePoint(&pt,TRUE);
	for(;;){
		n++;
		if(n>200) break;
		FixDot(&pt,TRUE,m_pTempPtn);
		if(!bNext) break;
		bNext=GetLinePoint(&pt);
	}

	CBitmap* pBmp	=new CBitmap;	//rbg}bvIuWFNg̍쐬
	CDC* pMemDC		=new CDC;		//foCXReLXgIuWFNg̍쐬


	//p^[rbg}bv
	pMemDC->CreateCompatibleDC(pDC);//foCXReLXg̍쐬
	pBmp->CreateBitmap(m_pTempPtn->m_size.cx,
						m_pTempPtn->m_size.cy,
						1,1,m_pTempPtn->m_pBuff);
	CBitmap* pOldBmp=pMemDC->SelectObject(pBmp);//rbg}bv̑I

	
	pDC->SetBkColor(RGB(255,0,0));
	pDC->SetTextColor(0);

	int l,t,cx,cy;
	if(m_ptEnd.x<m_ptStart.x) l=m_ptEnd.x; else l=m_ptStart.x;
	if(m_ptEnd.y<m_ptStart.y) t=m_ptEnd.y; else t=m_ptStart.y;
	cx=abs(m_ptEnd.x-m_ptStart.x)+1;
	cy=abs(m_ptEnd.y-m_ptStart.y)+1;


	pDC->StretchBlt(
		PTNEDIT_MARGIN+l*m_nZoomMulti,
		PTNEDIT_MARGIN+t*m_nZoomMulti,
		cx*m_nZoomMulti,
		cy*m_nZoomMulti,
		pMemDC,
		l,t,
		cx,cy,
		SRCINVERT);
	
	pMemDC->SelectObject(pOldBmp);
	delete pMemDC;
	delete pBmp;

	
	if(bUseLocalDC) delete pDC;
}

//ꎞ~̕`
//~ꎞp^[ɕ`悵āAʂɓ]
void CPEditor::DrawTempCircle(CDC* pDC)
{
	BOOL bUseLocalDC=FALSE;
	if(!pDC){
		bUseLocalDC=TRUE;
		pDC=new CClientDC(this);
		PrepareDC(pDC);
	}

	CPoint arraypt[8];

	int nXByte=((m_pTempPtn->m_size.cx+15)/16)*2;	//obt@XoCg
	int nBuffsize=nXByte*m_pTempPtn->m_size.cy;	//obt@̃TCY
	int n;
	BYTE* pb=m_pTempPtn->m_pBuff;
	for(n=0;n<nBuffsize;n++) *pb++=0;

	BOOL bNext=GetCirclePoint(arraypt,TRUE);
	n=0;
	for(;;){
		n++;
		if(n>200) break;
		FixDot(&(arraypt[0]),TRUE,m_pTempPtn);
		FixDot(&(arraypt[1]),TRUE,m_pTempPtn);
		FixDot(&(arraypt[2]),TRUE,m_pTempPtn);
		FixDot(&(arraypt[3]),TRUE,m_pTempPtn);
		FixDot(&(arraypt[4]),TRUE,m_pTempPtn);
		FixDot(&(arraypt[5]),TRUE,m_pTempPtn);
		FixDot(&(arraypt[6]),TRUE,m_pTempPtn);
		FixDot(&(arraypt[7]),TRUE,m_pTempPtn);
		if(!bNext) break;
		bNext=GetCirclePoint(arraypt);
	}

	CBitmap* pBmp	=new CBitmap;	//rbg}bvIuWFNg̍쐬
	CDC* pMemDC		=new CDC;		//foCXReLXgIuWFNg̍쐬


	//p^[rbg}bv
	pMemDC->CreateCompatibleDC(pDC);//foCXReLXg̍쐬
	pBmp->CreateBitmap(m_pTempPtn->m_size.cx,
						m_pTempPtn->m_size.cy,
						1,1,m_pTempPtn->m_pBuff);
	CBitmap* pOldBmp=pMemDC->SelectObject(pBmp);//rbg}bv̑I
	
	pDC->SetBkColor(RGB(255,0,0));
	pDC->SetTextColor(0);

	int l,t,cx,cy;
	if(m_ptEnd.x<m_ptStart.x) l=m_ptEnd.x; else l=m_ptStart.x;
	if(m_ptEnd.y<m_ptStart.y) t=m_ptEnd.y; else t=m_ptStart.y;
	cx=abs(m_ptEnd.x-m_ptStart.x)+1;
	cy=abs(m_ptEnd.y-m_ptStart.y)+1;


	pDC->StretchBlt(
		PTNEDIT_MARGIN+l*m_nZoomMulti,
		PTNEDIT_MARGIN+t*m_nZoomMulti,
		cx*m_nZoomMulti,
		cy*m_nZoomMulti,
		pMemDC,
		l,t,
		cx,cy,
		SRCINVERT);
	
	pMemDC->SelectObject(pOldBmp);
	delete pMemDC;
	delete pBmp;

	if(bUseLocalDC) delete pDC;
}




//_f[^Ɋm
void CPEditor::FixDot(CPoint* ppt,BOOL bOn,CLCoPtn* pPtn)
{
	if(!pPtn) pPtn=m_pPtn;
	if(   ppt->x >= pPtn->m_size.cx 
       || ppt->x < 0
	   || ppt->y >= pPtn->m_size.cy 
       || ppt->y < 0 ) return;

	BYTE bMask =0x80>>(ppt->x % 8);
	int  nXByte=((pPtn->m_size.cx+15)/16)*2;
	BYTE* pb=pPtn->m_pBuff + nXByte*ppt->y + ppt->x/8;
	if(bOn) *pb |= bMask;
	else    *pb &= ~bMask;
}

//f[^Ɋm
void CPEditor::FixLine(BOOL bOn)
{
	CPoint pt;
	int n=0;
	BOOL bNext=GetLinePoint(&pt,TRUE);
	for(;;){
		n++;
		if(n>200) break;
		FixDot(&pt,bOn);
		if(!bNext) break;
		bNext=GetLinePoint(&pt);
	}
}

//~f[^Ɋm
void CPEditor::FixCircle(BOOL bOn)
{
	CPoint arraypt[8];
	int n=0;

	BOOL bNext=GetCirclePoint(arraypt,TRUE);
	for(;;){
		n++;
		if(n>200) break;
		FixDot(&(arraypt[0]),bOn);
		FixDot(&(arraypt[1]),bOn);
		FixDot(&(arraypt[2]),bOn);
		FixDot(&(arraypt[3]),bOn);
		FixDot(&(arraypt[4]),bOn);
		FixDot(&(arraypt[5]),bOn);
		FixDot(&(arraypt[6]),bOn);
		FixDot(&(arraypt[7]),bOn);
		if(!bNext) break;
		bNext=GetCirclePoint(arraypt);
	}
}


//ꎞp^[̕`
void CPEditor::DrawTempPtn(CDC* pDC,LPRECT prc)
{
	if(!m_pTempPtn)return;

	BOOL bUseLocalDC=FALSE;
	if(!pDC){
		bUseLocalDC=TRUE;
		pDC=new CClientDC(this);
		PrepareDC(pDC);
	}
	

	int cx,cy,l,t;
	l=PTNEDIT_MARGIN+m_nZoomMulti*m_ptTempPtnOffset.x;
	t=PTNEDIT_MARGIN+m_nZoomMulti*m_ptTempPtnOffset.y;


	if(m_pTempPtn->m_pBuff){
		CBitmap* pBmp	=new CBitmap;	//rbg}bvIuWFNg̍쐬
		CDC* pMemDC		=new CDC;		//foCXReLXgIuWFNg̍쐬

		cx=m_pTempPtn->m_size.cx;
		cy=m_pTempPtn->m_size.cy;

		//p^[rbg}bv
		pMemDC->CreateCompatibleDC(pDC);//foCXReLXg̍쐬
		pBmp->CreateBitmap(cx,cy,1,1,m_pTempPtn->m_pBuff);
		CBitmap* pOldBmp=pMemDC->SelectObject(pBmp);//rbg}bv̑I

		pDC->SetBkColor(RGB(255,0,0));
		pDC->SetTextColor(0);

		pDC->StretchBlt(l,t,cx*m_nZoomMulti,cy*m_nZoomMulti,
			pMemDC,0,0,cx,cy,SRCINVERT);


		pMemDC->SelectObject(pOldBmp);
		delete pMemDC;
		delete pBmp;

		m_ptStart=m_ptTempPtnOffset;
		m_ptEnd.x=m_ptStart.x+m_pTempPtn->m_size.cx-1;
		m_ptEnd.y=m_ptStart.y+m_pTempPtn->m_size.cy-1;
	}
	if(bUseLocalDC) delete pDC;
}



void CPEditor::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	if(m_nOnCapture!=0) return;

	CClientDC dc(this);
	PrepareDC(&dc);
	
	dc.DPtoLP(&point);
	BOOL bOnPtn=LPtoPtnP(&point);
	
	if(m_nTool==0){
		if(bOnPtn && IsOnTemp(&point)){
			m_ptTrackOffset.x=m_ptTempPtnOffset.x-point.x;
			m_ptTrackOffset.y=m_ptTempPtnOffset.y-point.y;
			SetCapture();
			m_nOnCapture=L_CAPTURE;
		}else{
			if(FixTemp()){
				m_bDrawSelectRect=FALSE;
				InvalidateRectPtn(&dc);
				UpdateWindow();
			}
			if(!bOnPtn) return;

			m_ptStart=m_ptEnd=point;
			SetCapture();
			m_nOnCapture=L_CAPTURE;
			
			DrawSelectRect(&dc);
			m_bDrawTemp=TRUE;			//ꎞvf̕`tO𗧂Ă
		}
	}
	else if(m_nTool==1){
		if(!bOnPtn) return;

		SaveToUndoBuff();

		m_ptStart=m_ptEnd=point;
		FixDot(&point,TRUE);
		InvalidateRectPtn(&dc);
		UpdateWindow();
		SetCapture();
		m_nOnCapture=L_CAPTURE;
		m_bChange=TRUE;
	}
	else if(m_nTool==2){
		if(!bOnPtn) return;
		if(m_pTempPtn){
			return;
		}

		SaveToUndoBuff();

		m_ptStart=m_ptEnd=point;
		SetCapture();
		m_nOnCapture=L_CAPTURE;

		int nXByte=((m_pPtn->m_size.cx+15)/16)*2;	//obt@XoCg
		int nBuffsize=nXByte*m_pPtn->m_size.cy;	//obt@̃TCY
		//ꎞp^[̊m
		m_pTempPtn=new CLCoPtn;
		m_pTempPtn->m_size=CSize(m_pPtn->m_size.cx,m_pPtn->m_size.cy);
		m_ptTempPtnOffset=CPoint(0,0);
		//ꎞp^[̃obt@̊m
		m_pTempPtn->m_pBuff=new BYTE[nBuffsize];

		DrawTempLine(&dc);
		m_bDrawTemp=TRUE;			//ꎞvf̕`tO𗧂Ă
	}
	else if(m_nTool==3){
		if(!bOnPtn) return;
		if(m_pTempPtn){
			return;
		}

		SaveToUndoBuff();

		m_ptStart=m_ptEnd=point;
		SetCapture();
		m_nOnCapture=L_CAPTURE;


		int nXByte=((m_pPtn->m_size.cx+15)/16)*2;	//obt@XoCg
		int nBuffsize=nXByte*m_pPtn->m_size.cy;	//obt@̃TCY
		//ꎞp^[̊m
		m_pTempPtn=new CLCoPtn;
		m_pTempPtn->m_size=CSize(m_pPtn->m_size.cx,m_pPtn->m_size.cy);
		m_ptTempPtnOffset=CPoint(0,0);
		//ꎞp^[̃obt@̊m
		m_pTempPtn->m_pBuff=new BYTE[nBuffsize];

		DrawTempCircle(&dc);
		m_bDrawTemp=TRUE;			//ꎞvf̕`tO𗧂Ă
	}		
}

void CPEditor::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	if(m_nOnCapture!=0) return;

	CClientDC dc(this);
	PrepareDC(&dc);
	
	dc.DPtoLP(&point);
	BOOL bOnPtn=LPtoPtnP(&point);

	if(m_nTool==1){
		if(!bOnPtn) return;

		SaveToUndoBuff();

		m_ptStart=m_ptEnd=point;
		FixDot(&point,FALSE);
		InvalidateRectPtn(&dc);
		UpdateWindow();
		SetCapture();
		m_nOnCapture=R_CAPTURE;
		m_bChange=TRUE;

	}
	else if(m_nTool==2){
		if(!bOnPtn) return;

		SaveToUndoBuff();

		m_ptStart=m_ptEnd=point;
		SetCapture();
		m_nOnCapture=R_CAPTURE;
		
		int nXByte=((m_pPtn->m_size.cx+15)/16)*2;	//obt@XoCg
		int nBuffsize=nXByte*m_pPtn->m_size.cy;	//obt@̃TCY
		//ꎞp^[̊m
		m_pTempPtn=new CLCoPtn;
		m_pTempPtn->m_size=CSize(m_pPtn->m_size.cx,m_pPtn->m_size.cy);
		m_ptTempPtnOffset=CPoint(0,0);
		//ꎞp^[̃obt@̊m
		m_pTempPtn->m_pBuff=new BYTE[nBuffsize];

		DrawTempLine(&dc);
		m_bDrawTemp=TRUE;			//ꎞvf̕`tO𗧂Ă
	}
	else if(m_nTool==3){
		if(!bOnPtn) return;
		if(m_pTempPtn){
			return;
		}

		SaveToUndoBuff();

		m_ptStart=m_ptEnd=point;
		SetCapture();
		m_nOnCapture=R_CAPTURE;


		int nXByte=((m_pPtn->m_size.cx+15)/16)*2;	//obt@XoCg
		int nBuffsize=nXByte*m_pPtn->m_size.cy;	//obt@̃TCY
		//ꎞp^[̊m
		m_pTempPtn=new CLCoPtn;
		m_pTempPtn->m_size=CSize(m_pPtn->m_size.cx,m_pPtn->m_size.cy);
		m_ptTempPtnOffset=CPoint(0,0);
		//ꎞp^[̃obt@̊m
		m_pTempPtn->m_pBuff=new BYTE[nBuffsize];

		DrawTempCircle(&dc);
		m_bDrawTemp=TRUE;			//ꎞvf̕`tO𗧂Ă
	}
	//	CDialog::OnRButtonDown(nFlags, point);
}

void CPEditor::OnRButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
TRACE("CPEditor::OnRButtonUp\n");
	
	if(m_nOnCapture!=R_CAPTURE) return;

	::ReleaseCapture();
	m_nOnCapture=0;
	
	CClientDC dc(this);
	PrepareDC(&dc);

	if(m_nTool==2){
		//DrawTempLine(&dc);
		m_bDrawTemp=FALSE;

		delete m_pTempPtn;
		m_pTempPtn=NULL;

		FixLine(FALSE);
		m_bChange=TRUE;
		InvalidateRectPtn(&dc);
	}
	else if(m_nTool==3){
		m_bDrawTemp=FALSE;
		DrawTempCircle(&dc);
		delete m_pTempPtn;
		m_pTempPtn=NULL;

		FixCircle(FALSE);
		m_bChange=TRUE;
		InvalidateRectPtn(&dc);
	}
	//CDialog::OnRButtonUp(nFlags, point);
}




//p^[WłInvalidate
void CPEditor::InvalidateRectPtn(CDC* pDC,LPRECT prc /*=NULL*/)
{
//	CRect rc;
	if(!pDC){
		Invalidate();
		return;
	}
	CPoint pt1;
	CPoint pt2;
	if(!prc){
		pt1=m_ptStart;
		pt2=m_ptEnd;
	}else{
		pt1=CPoint(prc->left,prc->top);
		pt2=CPoint(prc->right,prc->bottom);
	}
	PtnPtoLP(&pt1);
	PtnPtoLP(&pt2);
	CRect rc(pt1,pt2);
	rc.NormalizeRect();
	rc.top-=m_nZoomMulti/2;
	rc.left-=m_nZoomMulti/2;
	rc.bottom+=m_nZoomMulti/2+1;
	rc.right+=m_nZoomMulti/2+1;

	pDC->LPtoDP(&rc);
	InvalidateRect(&rc);
}


//Ig̕`
void CPEditor::DrawSelectRect(CDC* pDC)
{
	BOOL bUseLocalDC=FALSE;
	if(!pDC){
		bUseLocalDC=TRUE;
		pDC=new CClientDC(this);
		PrepareDC(pDC);
	}

	CPoint pt1;
	CPoint pt2;
	pt1=m_ptStart;
	pt2=m_ptEnd;
	PtnPtoLP(&pt1);
	PtnPtoLP(&pt2);
	CRect rc(pt1,pt2);
	rc.NormalizeRect();
	rc.bottom++;
	rc.right++;
	pDC->SetBkColor(RGB(255,255,255));
	pDC->SetTextColor(0);

	pDC->DrawFocusRect(&rc);

	if(bUseLocalDC) delete pDC;
}


void CPEditor::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	if(m_nOnCapture!=L_CAPTURE) return;

	::ReleaseCapture();
	m_nOnCapture=0;
	
	CClientDC dc(this);
	PrepareDC(&dc);

	
	if(m_nTool==0){
		if(!m_pTempPtn){
			DrawSelectRect(&dc);
			m_bDrawTemp=FALSE;			//ꎞvf̕`tO𗧂Ă
			
			if(  abs(m_ptStart.x-m_ptEnd.x)>=2 ||
				 abs(m_ptStart.y-m_ptEnd.y)>=2    ){
				SaveToUndoBuff();
				if(ToTemp()){
					m_bDrawSelectRect=TRUE;
					InvalidateRectPtn(&dc);
					UpdateWindow();
				}else{
					m_bCanUndo=FALSE;
				}
			}
		}
	}
	else if(m_nTool==2){
		m_bDrawTemp=FALSE;
		delete m_pTempPtn;
		m_pTempPtn=NULL;
		FixLine(TRUE);
		m_bChange=TRUE;
		InvalidateRectPtn(&dc);
	}
	else if(m_nTool==3){
		m_bDrawTemp=FALSE;
		DrawTempCircle(&dc);
		delete m_pTempPtn;
		m_pTempPtn=NULL;
		FixCircle(TRUE);
		m_bChange=TRUE;
		InvalidateRectPtn(&dc);
	}
}

//VJ[\ʒuꎞp^[̃ItZbg߂
CPoint CPEditor::GetTrackTo(CPoint* pptCursor)
{
	CPoint pt(0,0);
	if(!m_pTempPtn) return pt;
	pt.x=pptCursor->x+m_ptTrackOffset.x;
	pt.y=pptCursor->y+m_ptTrackOffset.y;
	if(pt.x<0)	pt.x=0;
	else if(pt.x > m_pPtn->m_size.cx - m_pTempPtn->m_size.cx )
				pt.x=m_pPtn->m_size.cx - m_pTempPtn->m_size.cx ;
	if(pt.y<0)	pt.y=0;
	else if(pt.y > m_pPtn->m_size.cy - m_pTempPtn->m_size.cy )
				pt.y=m_pPtn->m_size.cy - m_pTempPtn->m_size.cy;
	return pt;
}




//w肵p^[Wꎞp^[ɏĂ邩
BOOL CPEditor::IsOnTemp(CPoint* ppt)
{
	if(!m_pTempPtn) return FALSE;
	if(		  ppt->x >= m_ptTempPtnOffset.x
		   && ppt->x <  m_ptTempPtnOffset.x+m_pTempPtn->m_size.cx
	       && ppt->y >= m_ptTempPtnOffset.y
		   && ppt->y <  m_ptTempPtnOffset.y+m_pTempPtn->m_size.cy
		)return TRUE;
	else return FALSE;
}

void CPEditor::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	m_nCursor=0;


	CClientDC dc(this);
	PrepareDC(&dc);

	dc.DPtoLP(&point);
	BOOL bOnPtn=LPtoPtnP(&point);
	
	if(m_nTool==0){
		if(bOnPtn && IsOnTemp(&point)) m_nCursor=IDC_CURSOR_MOVE;
	}
	

	if(!m_nOnCapture) return;

	if(m_nTool==0){
		if(m_pTempPtn){	//ꎞf[^ = ړ
			CPoint pt=GetTrackTo(&point);
			if(pt!=m_ptTempPtnOffset){
				DrawTempPtn(&dc,NULL);		//ꎞp^[̕`
				DrawSelectRect(&dc);

				CPoint ptOld=m_ptTempPtnOffset;
				m_ptTempPtnOffset=pt;
				CRect rc;
				rc=CRect(ptOld.x,ptOld.y,
					ptOld.x+m_pTempPtn->m_size.cx,
					ptOld.y+m_pTempPtn->m_size.cy);
				rc=CRect(pt.x,pt.y,
					pt.x+m_pTempPtn->m_size.cx,
					pt.y+m_pTempPtn->m_size.cy);
				DrawTempPtn(&dc,NULL);		//ꎞp^[̕`
				DrawSelectRect(&dc);
				m_bChange=TRUE;
			}
		}else{
			//Âg̏
			DrawSelectRect(&dc);
			//Vg̕`
			m_ptEnd=point;
			DrawSelectRect(&dc);
		}
	}

	else if(m_nTool==1){
		if(!bOnPtn) return;
		if(point==m_ptStart) return;
		m_ptStart=m_ptEnd=point;
		FixDot(&point,m_nOnCapture==L_CAPTURE);
		InvalidateRectPtn(&dc);
		UpdateWindow();
	}

	else if(m_nTool==2){
		//Â̏
		DrawTempLine(&dc);
		//V̕`
		m_ptEnd=point;
		DrawTempLine(&dc);
	}
	else if(m_nTool==3){
		//Â̏
		DrawTempCircle(&dc);
		//V̕`
		m_ptEnd=point;
		DrawTempCircle(&dc);
	}


//	CWnd::OnMouseMove(nFlags, point);
}


//m_ptStartm_ptEndŊ͈͂ꎞp^[Ɉړ
BOOL CPEditor::ToTemp()
{
	if(m_pTempPtn!=NULL) return FALSE;
	//W̐K
	CPoint pt1=m_ptStart;
	CPoint pt2=m_ptEnd;
	CRect rc(pt1,pt2);
	rc.NormalizeRect();
	//TCY̌
	int cx=rc.right-rc.left+1;
	int cy=rc.bottom-rc.top+1;
	int nXByteD=((cx+15)/16)*2;	//obt@XoCg
	int nBuffsize=nXByteD*cy;	//obt@̃TCY

	int nXByteS=((m_pPtn->m_size.cx+15)/16)*2;	//]obt@XoCg
	//ꎞp^[̊m
	m_pTempPtn=new CLCoPtn;
	m_pTempPtn->m_size=CSize(cx,cy);
	m_ptTempPtnOffset=CPoint(rc.left,rc.top);
	//ꎞp^[̃obt@̊m
	m_pTempPtn->m_pBuff=new BYTE[nBuffsize];
	//}XNƃ|C^̐ݒ
	BYTE bMaskS,bMaskD,bMaskSTop;
	bMaskSTop=0x80>>(rc.left%8);
	BYTE *pbS,*pbD,*pbSTop,*pbDTop;
	pbSTop=m_pPtn->m_pBuff+rc.left/8+nXByteS*rc.top;
	pbDTop=m_pTempPtn->m_pBuff;
	//ۂ̕
	int x,y;
	BOOL bDot=FALSE;
	for(y=0;y<cy;y++){
		pbS=pbSTop;
		pbD=pbDTop;
		pbSTop+=nXByteS;
		pbDTop+=nXByteD;

		bMaskS=bMaskSTop;
		bMaskD=0x80;
		for(x=0;x<cx;x++){

			if(bMaskD==0x80)	*pbD=0;

			//hbg̃eXgƈړ
			if(*pbS & bMaskS){	//hbgPȂ...
				*pbS &= ~bMaskS;	//Ƃ̃hbgOFFɂ
				*pbD |= bMaskD;		//]̃hbgONɂ
				bDot=TRUE;
			}
			//}XN̈ړ
			if(bMaskS==1){
				pbS++;
				bMaskS=0x80;
			}else{
				bMaskS>>=1;
			}
			if(bMaskD==1){
				pbD++;
				bMaskD=0x80;
			}else{
				bMaskD>>=1;
			}
		}
	}
	if(!bDot){
		delete m_pTempPtn;
		m_pTempPtn=NULL;
		return FALSE;
	}
	return TRUE;
}

//ꎞp^[m
BOOL CPEditor::FixTemp()
{
	if(m_pTempPtn==NULL) return FALSE;
	//TCY̌
	int cx=m_pTempPtn->m_size.cx;
	if(m_ptTempPtnOffset.x+cx > m_pPtn->m_size.cx) cx=m_pPtn->m_size.cx-m_ptTempPtnOffset.x;

	int cy=m_pTempPtn->m_size.cy;
	if(m_ptTempPtnOffset.y+cy > m_pPtn->m_size.cy) cy=m_pPtn->m_size.cy-m_ptTempPtnOffset.y;

	if(cx<=0 || cy<=0){
		delete m_pTempPtn;
		m_pTempPtn=NULL;
		return TRUE;
	}


	int nXByteS=((m_pTempPtn->m_size.cx+15)/16)*2;	//obt@XoCg
	int nXByteD=((m_pPtn->m_size.cx+15)/16)*2;		//]obt@XoCg

	m_ptStart=m_ptTempPtnOffset;
	m_ptEnd.x=m_ptStart.x+m_pTempPtn->m_size.cx-1;
	m_ptEnd.y=m_ptStart.y+m_pTempPtn->m_size.cy-1;
	
	//}XNƃ|C^̐ݒ
	BYTE bMaskS,bMaskD,bMaskDTop;
	bMaskDTop=0x80>>(m_ptTempPtnOffset.x%8);
	BYTE *pbS,*pbD,*pbSTop,*pbDTop;
	pbSTop=m_pTempPtn->m_pBuff;
	pbDTop=m_pPtn->m_pBuff+m_ptTempPtnOffset.x/8+m_ptTempPtnOffset.y*nXByteD;
	//ۂ̕
	int x,y;
	for(y=0;y<cy;y++){
		pbS=pbSTop;
		pbD=pbDTop;
		pbSTop+=nXByteS;
		pbDTop+=nXByteD;

		bMaskD=bMaskDTop;
		bMaskS=0x80;
		for(x=0;x<cx;x++){
			//hbg̃eXgƈړ
			if(*pbS & bMaskS){	//hbgPȂ...
				*pbD |= bMaskD;		//]̃hbgONɂ
			}
			//}XN̈ړ
			if(bMaskS==1){
				pbS++;
				bMaskS=0x80;
			}else{
				bMaskS>>=1;
			}
			if(bMaskD==1){
				pbD++;
				bMaskD=0x80;
			}else{
				bMaskD>>=1;
			}
		}
	}
	delete m_pTempPtn;
	m_pTempPtn=NULL;
	m_bDrawSelectRect=FALSE;
//	m_bChange=TRUE;
	return TRUE;
}

//ꎞf[^݂TRUEԂ
BOOL CPEditor::CanCopy()
{
	if(m_pTempPtn==NULL || m_nTool!=0) return FALSE;
	else return TRUE;
}



//ꎞp^[Nbv{[hɓ]
void CPEditor::Copy()
{
	if(m_nTool!=0) return;
	if(m_pTempPtn==NULL) return;
	HBITMAP hBmp;
	HDC		hDC,hMemDC;
	hDC=::GetDC(m_hWnd);
	hMemDC=::CreateCompatibleDC(hDC);
	hBmp=::CreateBitmap(
		m_pTempPtn->m_size.cx,
		m_pTempPtn->m_size.cy,
		1,1,m_pTempPtn->m_pBuff);
	::SelectObject(hMemDC,hBmp);
	::PatBlt(hMemDC,0,0,
		m_pTempPtn->m_size.cx,
		m_pTempPtn->m_size.cy,
		DSTINVERT);
	OpenClipboard();
	::EmptyClipboard();
	::SetClipboardData(CF_BITMAP,hBmp);
	::CloseClipboard();
	::DeleteDC(hMemDC);
	::ReleaseDC(m_hWnd,hDC);
}

//Undo̎s
void CPEditor::Undo()
{
	if(!m_bCanUndo) return;
	delete m_pTempPtn;
	m_pTempPtn=NULL;

	int x,y,n,buffsize;
	x=m_pPtn->m_size.cx;
	y=m_pPtn->m_size.cy;
	buffsize=((x+15)/16)*2*y;
	for(n=0;n<buffsize;n++) m_pPtn->m_pBuff[n]=m_pUndoBuff[n];
	m_bCanUndo=FALSE;
	
	m_bDrawSelectRect=FALSE;
	Invalidate();
}

//ƃp^[Undoobt@֑Ҕ
void  CPEditor::SaveToUndoBuff()
{
	int x,y,n,buffsize;
	x=m_pPtn->m_size.cx;
	y=m_pPtn->m_size.cy;
	buffsize=((x+15)/16)*2*y;
	for(n=0;n<buffsize;n++) m_pUndoBuff[n]=m_pPtn->m_pBuff[n];
	m_bCanUndo=TRUE;
}

//ꎞp^[
void CPEditor::Clear()
{
	if(m_nTool!=0) return;
	if(m_pTempPtn==NULL) return;
	delete m_pTempPtn;
	m_pTempPtn=NULL;
	m_bChange=TRUE;
	CClientDC dc(this);				//NCAgGÃfoCXReLXg
	PrepareDC(&dc);					//WindowOrg̐ݒ
	m_bDrawSelectRect=FALSE;
	InvalidateRectPtn(&dc);
}

//Nbv{[hꎞp^[ɓ]
void CPEditor::Paste()
{
	HBITMAP hBmpS,hBmpD,hOldBmp;
	HDC hMemDCS,hMemDCD;
	BITMAP bm;
	int cx,cy;

	if(!m_pPtn) return;

	SetTool(0);

	CClientDC dc(this);
	PrepareDC(&dc);

	SaveToUndoBuff();

	OpenClipboard();
	hBmpS=(HBITMAP)::GetClipboardData(CF_BITMAP);
	if(hBmpS){
		//Nbv{[h̃p^[foCXReLXg
		hMemDCS=::CreateCompatibleDC(dc.m_hDC);
		::SelectObject(hMemDCS,hBmpS);
		//]TCY߂
		::GetObject(hBmpS,sizeof(BITMAP),&bm);
		cx=bm.bmWidth;
		cy=bm.bmHeight;
		if(cx>m_pPtn->m_size.cx) cx=m_pPtn->m_size.cx;
		if(cy>m_pPtn->m_size.cy) cy=m_pPtn->m_size.cy;
		//p^[̓]̃foCXReLXg
		hMemDCD=::CreateCompatibleDC(dc.m_hDC);
		hBmpD=::CreateBitmap(cx,cy,1,1,NULL);
		hOldBmp=(HBITMAP)::SelectObject(hMemDCD,hBmpD);
		//F̐ݒ
		::BitBlt(hMemDCD,0,0,cx,cy,hMemDCS,0,0,NOTSRCCOPY);
		hBmpD=(HBITMAP)::SelectObject(hMemDCD,hOldBmp);
		int nBuffSize=((cx+15)/16)*2*cy;
		BYTE* pBuff=new BYTE[nBuffSize];
		::GetBitmapBits(hBmpD,nBuffSize,pBuff);		
		::DeleteDC(hMemDCS);
		::DeleteDC(hMemDCD);
		::DeleteObject(hBmpD);
		CPoint ptTemp=m_pointWindowOrg;
		LPtoPtnP(&ptTemp);

		m_ptTempPtnOffset=ptTemp;
		m_pTempPtn=new CLCoPtn;
		m_pTempPtn->m_size=CSize(cx,cy);
		m_pTempPtn->m_pBuff=pBuff;
		m_ptStart=m_ptTempPtnOffset;
		m_ptEnd=CPoint(cx,cy);
		DrawTempPtn(NULL,NULL);		//ꎞp^[̕`
		DrawSelectRect(NULL);
		m_bDrawSelectRect=TRUE;
		m_bChange=TRUE;
	}
	//hBmpS̓Nbv{[h̃f[^Ȃ̂ō폜Ȃ
	::CloseClipboard();
	//Invalidate();
}


BOOL CPEditor::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	HCURSOR hCursor;
	if(!m_nCursor) hCursor=AfxGetApp()->LoadStandardCursor(IDC_ARROW);
	else		   hCursor=AfxGetApp()->LoadCursor(m_nCursor);	
	::SetCursor(hCursor);
	return TRUE;
	//return CWnd::OnSetCursor(pWnd, nHitTest, message);
}

void CPEditor::OnDestroy() 
{
	CWnd::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	FixTemp();
}
