// PtnView.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "lco.h"

#include "Draw.h"
#include "PartInfo.h"
#include "PtnView.h"
#include "LCoFont.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define PTN_MARGIN 20

/////////////////////////////////////////////////////////////////////////////
// CPtnView

CPtnView::CPtnView()
{
	m_pPtn=NULL;
	m_pointWindowOrg=CPoint(0,0);
	m_sizeView=CSize(0,0);
}

CPtnView::~CPtnView()
{
}



BEGIN_MESSAGE_MAP(CPtnView, CWnd)
	//{{AFX_MSG_MAP(CPtnView)
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_VSCROLL()
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()





//iւ̃|C^ݒ肷
void CPtnView::SetPtn( CLCoPtn* pPtn)
{
	m_pPtn=pPtn;
	m_pointWindowOrg=CPoint(0,0);
	if(m_pPtn){
		m_sizeView.cx=m_pPtn->m_size.cx+PTN_MARGIN*2;
		m_sizeView.cy=m_pPtn->m_size.cy+PTN_MARGIN*2;
	}else{
		m_sizeView=CSize(0,0);
	}
	
	Resize();
	Invalidate();
}






/////////////////////////////////////////////////////////////////////////////


//WindowOrg̐ݒ
void CPtnView::PrepareDC(CDC* pDC)
{
	pDC->SetWindowOrg(m_pointWindowOrg);
}

//wi̕`
//

void CPtnView::OnPaint() 
{
	CPaintDC dc(this); // `p̃foCX ReLXg
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	
	// `pbZ[WƂ CWnd::OnPaint() ĂяoĂ͂܂
	if(!m_pPtn) return;
	PrepareDC(&dc);					//WindowOrg̐ݒ

	if(m_pPtn->m_pBuff){
		CBitmap* pBmp	=new CBitmap;	//rbg}bvIuWFNg̍쐬
		CDC* pMemDC		=new CDC;		//foCXReLXgIuWFNg̍쐬
	
		int cx=m_pPtn->m_size.cx;
		int cy=m_pPtn->m_size.cy;

		//p^[rbg}bv
		pMemDC->CreateCompatibleDC(&dc);//foCXReLXg̍쐬
		pBmp->CreateBitmap(cx,cy,1,1,m_pPtn->m_pBuff);
		CBitmap* pOldBmp=pMemDC->SelectObject(pBmp);//rbg}bv̑I
	
		dc.SelectStockObject(BLACK_BRUSH);
		dc.BitBlt(PTN_MARGIN,PTN_MARGIN,cx,cy,pMemDC,0,0,0x00E20746);
				// 00E20746	DSPDxax
				// [P]   1   1   1   1   0   0   0   0
				// [S]   1   1   0   0   1   1   0   0
				// [D]   1   0   1   0   1   0   1   0
				// -------------------------------------
				//       1   1   1   0   0   0   1   0  ----> 0xE2
		
		pMemDC->SelectObject(pOldBmp);
		delete pMemDC;
		delete pBmp;
	}
}

//WM_SIZE𑗂
void CPtnView::Resize()
{
	CRect rc;
	SendMessage(WM_SIZE,0,MAKELONG(m_sizeClient.cx,m_sizeClient.cy));
}


//WM_SIZE bZ[Wnh
void CPtnView::OnSize(UINT nType, int cx, int cy) 
{
	CWnd::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	m_sizeClient.cx=cx;
	m_sizeClient.cy=cy;

	SCROLLINFO si;
	si.fMask=SIF_RANGE|SIF_POS|SIF_PAGE;
	int nPos;

	//nPos=GetScrollPos(SB_VERT);
	nPos=m_pointWindowOrg.y;
	if(nPos>(m_sizeView.cy-m_sizeClient.cy))nPos=m_sizeView.cy-m_sizeClient.cy;
	if(nPos<0) nPos=0;
	si.nMin=0;
	si.nMax=m_sizeView.cy;
	si.nPage=m_sizeClient.cy;
	si.nPos =nPos;
	m_pointWindowOrg.y=nPos;
	SetScrollInfo(SB_VERT,&si,TRUE);

	nPos=m_pointWindowOrg.x;
	if(nPos>(m_sizeView.cx-m_sizeClient.cx))nPos=m_sizeView.cx-m_sizeClient.cx;
	if(nPos<0) nPos=0;
	si.nMin=0;
	si.nMax=m_sizeView.cx;
	si.nPage=m_sizeClient.cx;
	si.nPos =nPos;
	m_pointWindowOrg.x=nPos;
	SetScrollInfo(SB_HORZ,&si,TRUE);
}

//wItZbgԂ̐XN[ XN[ TRUE Ԃ
BOOL CPtnView::VScrollOffset(int nOffset)
{
	SCROLLINFO si;
	GetScrollInfo(SB_VERT,&si);
	int nCurrentPos=si.nPos;
	int nNewPos=nCurrentPos+nOffset;

	if(nNewPos<0)nNewPos=0;
	else if(nNewPos>si.nMax-(int)si.nPage+1) nNewPos=si.nMax-si.nPage+1;
	si.nPos=m_pointWindowOrg.y=nNewPos;
	if(nCurrentPos!=nNewPos){
		ScrollWindow(0,nCurrentPos-nNewPos);
		si.fMask=SIF_RANGE|SIF_POS|SIF_PAGE;
		SetScrollInfo(SB_VERT,&si);
		UpdateWindow();
		return TRUE;
	}
	return FALSE;
}

//wItZbgԂ̐XN[ XN[ TRUE Ԃ
BOOL CPtnView::HScrollOffset(int nOffset)
{
	SCROLLINFO si;
	GetScrollInfo(SB_HORZ,&si);
	int nCurrentPos=si.nPos;
	int nNewPos=nCurrentPos+nOffset;

	if(nNewPos<0)nNewPos=0;
	else if(nNewPos>si.nMax-(int)si.nPage+1) nNewPos=si.nMax-si.nPage+1;
	si.nPos=m_pointWindowOrg.x=nNewPos;
	if(nCurrentPos!=nNewPos){
		ScrollWindow(nCurrentPos-nNewPos,0);
		si.fMask=SIF_RANGE|SIF_POS|SIF_PAGE;
		SetScrollInfo(SB_HORZ,&si);
		UpdateWindow();
		return TRUE;
	}
	return FALSE;
}


void CPtnView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	SetFocus();
	int nOffset;
	switch(nSBCode){
	case SB_THUMBTRACK:
	case SB_THUMBPOSITION:
		nOffset=nPos-m_pointWindowOrg.y;
		break;
	case SB_LINEUP:
		nOffset=-20;
		break;
	case SB_LINEDOWN:
		nOffset=+20;
		break;
	case SB_PAGEUP:
		nOffset=-100;
		break;
	case SB_PAGEDOWN:
		nOffset=+100;
		break;
	default:
		return;
	}
	VScrollOffset(nOffset);
}

void CPtnView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	SetFocus();
	int nOffset;
	switch(nSBCode){
	case SB_THUMBTRACK:
	case SB_THUMBPOSITION:
		nOffset=nPos-m_pointWindowOrg.x;
		break;
	case SB_LINEUP:
		nOffset=-20;
		break;
	case SB_LINEDOWN:
		nOffset=+20;
		break;
	case SB_PAGEUP:
		nOffset=-100;
		break;
	case SB_PAGEDOWN:
		nOffset=+100;
		break;
	default:
		return;
	}
	HScrollOffset(nOffset);

	//CWnd::OnHScroll(nSBCode, nPos, pScrollBar);
}





